﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CheckCellsHasValues
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            myGrid.DataContext = Data.GetData(10, 1, 8);
        }

       

        private void Button_Click(object sender, RoutedEventArgs e)
        {
           
        }

        private void myGrid_RecordAdded(object sender, Infragistics.Windows.DataPresenter.Events.RecordAddedEventArgs e)
        {
            e.Record.Tag = "new";
        }

        private void myGrid_RecordUpdating(object sender, Infragistics.Windows.DataPresenter.Events.RecordUpdatingEventArgs e)
        {
            if (e.Record.Tag != null)
            {
                //you can cancel the update here
                Data d = e.Record.DataItem as Data;
                string s = d.Value.ToString();
                if (d.Label == null || d.Low.ToString() == null || 
                    d.Low == 0 || d.Value  == 0
                    || d.Value.ToString() == null)
                {
                    MessageBox.Show("Please fill all fields");
                    e.Record.CancelUpdate();
                }
               
            }
        }

        private void myGrid_RecordUpdated(object sender, Infragistics.Windows.DataPresenter.Events.RecordUpdatedEventArgs e)
        {
            if (e.Record.Tag != null)
            {
                e.Record.Tag = null;      
            }
        }
    }
    
    public class Data : INotifyPropertyChanged
    {
        private int low;
        private int value;
        private string label;


        public string Label
        {
            get { return label; }
            set
            {
                label = value;
                PropChanged("Label");
            }
        }

   

        
        public int Low
        {
            get { return low; }
            set
            {
                low = value;
                PropChanged("Low");
            }
        }

        public int Value
        {
            get { return value; }
            set
            {
                this.value = value;
                PropChanged("Value");
            }
        }

      

        public static ObservableCollection<Data> GetData(int points, int rangeStart, int rangeEnd)
        {
            ObservableCollection<Data> data = new ObservableCollection<Data>();
            Random r = new Random();
            for (int i = 0; i < points; i++)
            {
                data.Add(new Data
                {
                    
                    Label = "Item " + i,
                    Low = r.Next(rangeStart, rangeEnd),
                    Value = r.Next(rangeStart, rangeEnd),
                });
            }

            return data;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    } 
				
}
